# Imports

from libc.stdio cimport printf, fprintf, fwrite, putchar, stderr, stdout
from libc.stdlib cimport malloc, free, atoi
from libc.string cimport strlen, strchr, strdup, strndup, strncmp, memset, memcpy, strcpy, strncpy, memmove
from libc.stddef cimport size_t
#from libc.signal cimport sig_atomic_t, signal, SIGTERM, SIGINT
from libcpp cimport bool
from libc.stdint cimport uint8_t, uint16_t, uint32_t, uint64_t
from cpython.exc cimport PyErr_CheckSignals

# First, the hacky way to have Cy_INCREF available:

cdef extern from "Python.h" nogil:
    cdef void Cy_INCREF(cyobject)
    cdef void Cy_DECREF(cyobject)

cdef extern from "mongoose/mongoose.h" nogil:
    cdef enum:
        MG_MAX_HTTP_HEADERS
    ctypedef struct mg_mgr:
        pass
    ctypedef struct mg_iobuf:
        unsigned char *buf
        size_t size, len
    ctypedef struct mg_addr:
        uint16_t port
        uint32_t ip
        uint8_t ip6[16]
        bool is_ip6

    ctypedef struct mg_str:
        const char *ptr;
        size_t len

    ctypedef struct mg_http_header:
        mg_str name
        mg_str value

    ctypedef struct mg_tls_opts:
        const char *ca
        const char *cert
        const char *certkey
        const char *ciphers
        mg_str srvname

    ctypedef struct mg_http_serve_opts:
        const char *root_dir
        const char *ssi_pattern

    ctypedef struct mg_connection:
        mg_connection *next
        mg_mgr *mgr
        mg_addr peer
        void *fd
        unsigned long id
        mg_iobuf recv
        mg_iobuf send
        void *fn_data
        void *pfn_data
        char label[50]
        unsigned is_hexdumping
        unsigned is_closing

    ctypedef void (*mg_event_handler_t)(mg_connection *, int ev,
                                   void *ev_data, void *fn_data)

    ctypedef struct mg_http_message:
        mg_str method, uri, query, proto
        mg_http_header headers[MG_MAX_HTTP_HEADERS]
        mg_str body
        mg_str head
        mg_str chunk
        mg_str message

    #cdef void mg_serve_http(mg_connection *nc, http_message *hm,
    #                        mg_serve_http_opts opts)

    cdef void mg_http_serve_dir(mg_connection *, mg_http_message *hm,
                                mg_http_serve_opts *)
 
    cdef void mg_send_websocket_frame(mg_connection *nc, int op_and_flags,
                             const void *data, size_t data_len)

    cdef int mg_send(mg_connection *, const void *, size_t)

    cdef mg_connection *mg_http_listen(mg_mgr *, const char *url,
                                     mg_event_handler_t fn, void *fn_data)
    cdef void mg_mgr_poll(mg_mgr *, int ms)
    cdef void mg_mgr_free(mg_mgr *)
    cdef void mg_mgr_init(mg_mgr *)
    cdef int mg_tls_init(mg_connection *, mg_tls_opts *)

    cdef mg_connection *mg_connect(mg_mgr *, const char *url,
                                 mg_event_handler_t fn, void *fn_data)

    cdef mg_str mg_mk_str(const char *s)
    cdef void mg_log_set(const char *spec)

    cdef int mg_strcmp(const mg_str str1, const mg_str str2)

    cdef int mg_printf(mg_connection *, const char *fmt, ...)

    cdef int mg_url_is_ssl(const char *url)

    cdef mg_str mg_url_host(const char *url)
    cdef const char *mg_url_uri(const char *url)

    cdef size_t mg_iobuf_delete(mg_iobuf *, size_t)
    

    cdef enum mongoose_event:
        MG_EV_CONNECT
        MG_EV_HTTP_MSG
        MG_EV_READ
        MG_EV_WRITE
        MG_EV_CLOSE
        MG_EV_POLL

