
cdef char *s_backend_url = "http://www.ladyada.net" #"https://www.python.org/""
cdef const char *s_listen_url = "http://localhost:8000"
cdef mg_tls_opts opts



cdef void forward_request(mg_http_message *hm, mg_connection *c, char *s_backend_url) nogil:
  cdef size_t i, max  = sizeof(hm.headers) // sizeof(hm.headers[0])
  cdef const char *v
  cdef const char *host = mg_url_host(s_backend_url).ptr
  cdef size_t l, t = strlen(host)
  cdef char *h = "Host"
  cdef char *slash = strchr(<char *>host, '/')

  #mg_printf(c, "%.*s\r\n",
  #          <int > (hm.proto.ptr + hm.proto.len - hm.message.ptr),
  #          hm.message.ptr)
  # Send request with 
  mg_printf(c, "%.*s %s %.*s\r\n",
            <int> hm.method.len, hm.method.ptr, mg_url_uri(s_backend_url),
            <int> hm.proto.len, hm.proto.ptr)
  fprintf(stdout, "%.*s %s %.*s\r\n",
            <int> hm.method.len, hm.method.ptr, mg_url_uri(s_backend_url),
            <int> hm.proto.len, hm.proto.ptr)
  if slash != NULL:
    t = <int> (slash - host)
  i = 0
  while i < max:
    if hm.headers[i].name.len > 0:
      v = hm.headers[i].value.ptr
      l = hm.headers[i].value.len
      if strncmp(hm.headers[i].name.ptr, h, 4) == 0:
        l = t #mg_url_host(s_backend_url).len #t
        v = host
      fprintf(stderr, "%.*s: %.*s\r\n", hm.headers[i].name.len,
               hm.headers[i].name.ptr, <int> l, v)
      mg_printf(c, "%.*s: %.*s\r\n", hm.headers[i].name.len,
                hm.headers[i].name.ptr, <int> l, v)
    i += 1

  mg_send(c, "\r\n", 2)
  mg_send(c, hm.body.ptr, hm.body.len)
  fprintf(stdout, "FORWARDING: %.*s %.*s\n", <int> hm.method.len, hm.method.ptr,
                 <int> hm.uri.len, hm.uri.ptr)
  #LOG(LL_DEBUG, ("FORWARDING: %.*s %.*s", <int> hm.method.len, hm.method.ptr,
  #               <int> hm.uri.len, hm.uri.ptr))


cdef void fn_handler(mg_connection *c, int ev, void *ev_data, void *fn_data) nogil:
  global s_backend_url
  cdef mg_http_message *hm
  cdef mg_connection *c2 = <mg_connection *> fn_data
  cdef char *backend_url
  cdef char t[255]
  if (ev == mongoose_event.MG_EV_HTTP_MSG):
    hm = <mg_http_message *> ev_data
    if (c.label[0] != 'B' and c2 == NULL):
      # Client request, create backend connection Note that we're passing
      # client connection `c` as fn_data for the created backend connection.
      strncpy(t, hm.uri.ptr, hm.uri.len)
      t[hm.uri.len] = '\0'
      backend_url = t + 1
      if strncmp(backend_url, "https://", 8) == 0 or strncmp(backend_url, "http://", 7) == 0:
        s_backend_url = backend_url
      fprintf(stdout, "Connecting to backend: %s%s%.*s\n", s_backend_url,
              <char *> ("?" if  hm.query.len > 0 else ""), hm.query.len, hm.query.ptr)
      c2 = mg_connect(c.mgr, <const char *> s_backend_url, fn_handler, c)
      c.fn_data = c2
      if (c2 != NULL):
        c2.is_hexdumping = 1
        c2.label[0] = 'B'  # Mark this connection as backend
      else:
        c.is_closing = 1
    if (c2 != NULL and c2.label[0] == 'B'):
      forward_request(hm, c2, s_backend_url)
  elif (ev == mongoose_event.MG_EV_READ):
    if (c.label[0] == 'B' and c2 != NULL):
      # All incoming data from the backend, forward to the client
      mg_send(c2, c.recv.buf, c.recv.len)
      mg_iobuf_delete(&c.recv, c.recv.len)
  elif (ev == mongoose_event.MG_EV_CONNECT): 
    if mg_url_is_ssl(<const char *> s_backend_url):
      mg_tls_init(c, &opts)
  elif (ev == mongoose_event.MG_EV_CLOSE):
    if (c2 != NULL):
      c2.is_closing = 1
    c.fn_data = NULL


cpdef void main():
    global opts
    cdef mg_mgr mgr
    opts.ca = "cacert.pem"
    mg_log_set("1")
    mg_mgr_init(&mgr)
    mg_http_listen(&mgr, s_listen_url, fn_handler, NULL)
    while True:
      mg_mgr_poll(&mgr, 50)
      PyErr_CheckSignals()
    mg_mgr_free(&mgr)

