from distutils.core import setup
from distutils.extension import Extension
from Cython.Build import cythonize

setup(
  ext_modules = cythonize([
    Extension("http_proxy",
              language="c++",
              sources=["http_proxy.pyx", "mongoose/mongoose.c"],
              extra_compile_args=["-DMG_ENABLE_OPENSSL=1", "-I/usr/local/ssl/include", "-I/usr/include", "-L/usr/local/ssl/lib", "-lssl", "-lcrypto"],
              extra_link_args=["-DMG_ENABLE_OPENSSL=1", "-I/usr/local/ssl/include", "-L/usr/local/ssl/lib", "-lssl", "-lcrypto"],
              define_macros=[("MG_IO_SIZE", 512), ("MG_ENABLE_LOG", 1), ("MG_ENABLE_IPV6", 1)]
   )
  ])
)
